﻿Imports System.Net
Imports System.Text
Imports System.IO
Imports System.Web.Script.Serialization

Public Class BCS_lib

    Public Shared Function GetDin(ByVal URL As String, Optional ByVal UserName As String = "", Optional ByVal UserPass As String = "") As Din_Class

        Dim TempData As String = ""

        TempData = WRequest(URL, "GET", , UserName, UserPass)
        Dim js As New JavaScriptSerializer
        Dim results As Din_Class = js.Deserialize(Of Din_Class)(TempData)

        Return results

    End Function

    Public Shared Function SetDin(ByVal URL As String, ByVal POSTData As Generic.List(Of Din_Class), Optional ByVal UserName As String = "", Optional ByVal UserPass As String = "") As String

        Try

            Dim serializer As New JavaScriptSerializer()
            Dim serializedResult As String = serializer.Serialize(POSTData)

            serializedResult = Mid(serializedResult, 2, serializedResult.Length - 2) 'Remove the brackets

            Return WRequest(URL, "POST", serializedResult, UserName, UserPass)

        Catch ex As Exception
            Return ex.Message
        End Try

    End Function

    Public Shared Function GetTemp(ByVal URL As String, Optional ByVal UserName As String = "", Optional ByVal UserPass As String = "") As Temp_Class

        Dim TempData As String = ""

        TempData = WRequest(URL, "GET", , UserName, UserPass)
        Dim js As New JavaScriptSerializer
        Dim results As Temp_Class = js.Deserialize(Of Temp_Class)(TempData)

        Return results

    End Function

    Public Shared Function SetTemp(ByVal URL As String, ByVal POSTData As Generic.List(Of Temp_Class), Optional ByVal UserName As String = "", Optional ByVal UserPass As String = "") As String

        Try

            Dim serializer As New JavaScriptSerializer()
            Dim serializedResult As String = serializer.Serialize(POSTData)

            serializedResult = Mid(serializedResult, 2, serializedResult.Length - 2) 'Remove the brackets, data is not in array

            Return WRequest(URL, "POST", serializedResult, UserName, UserPass)

        Catch ex As Exception
            Return ex.Message
        End Try

    End Function

    Public Shared Function GetOutput(ByVal URL As String, Optional ByVal UserName As String = "", Optional ByVal UserPass As String = "") As Output_Class

        Dim TempData As String = ""

        TempData = WRequest(URL, "GET", , UserName, UserPass)
        Dim js As New JavaScriptSerializer
        Dim results As Output_Class = js.Deserialize(Of Output_Class)(TempData)

        Return results

    End Function

    Public Shared Function SetOutput(ByVal URL As String, ByVal POSTData As Generic.List(Of Output_Class), Optional ByVal UserName As String = "", Optional ByVal UserPass As String = "") As String

        Try

            Dim serializer As New JavaScriptSerializer()
            Dim serializedResult As String = serializer.Serialize(POSTData)

            serializedResult = Mid(serializedResult, 2, serializedResult.Length - 2) 'Remove the brackets, data is not in array

            Return WRequest(URL, "POST", serializedResult, UserName, UserPass)

        Catch ex As Exception
            Return ex.Message
        End Try

    End Function

    Public Shared Function GetProcess(ByVal URL As String, Optional ByVal UserName As String = "", Optional ByVal UserPass As String = "") As Process_Class

        Dim TempData As String = ""

        TempData = WRequest(URL, "GET", , UserName, UserPass)
        Dim js As New JavaScriptSerializer
        Dim results As Process_Class = js.Deserialize(Of Process_Class)(TempData)

        Return results

    End Function

    Public Shared Function SetProcess(ByVal URL As String, ByVal POSTData As Generic.List(Of Process_Class), Optional ByVal UserName As String = "", Optional ByVal UserPass As String = "") As String

        Try

            Dim serializer As New JavaScriptSerializer()
            Dim serializedResult As String = serializer.Serialize(POSTData)

            serializedResult = Mid(serializedResult, 2, serializedResult.Length - 2) 'Remove the brackets, data is not in array

            Return WRequest(URL, "POST", serializedResult, UserName, UserPass)

        Catch ex As Exception
            Return ex.Message
        End Try

    End Function

    Public Shared Function GetState(ByVal URL As String, Optional ByVal UserName As String = "", Optional ByVal UserPass As String = "") As State_Class

        Dim TempData As String = ""

        TempData = WRequest(URL, "GET", , UserName, UserPass)
        Dim js As New JavaScriptSerializer
        Dim results As State_Class = js.Deserialize(Of State_Class)(TempData)

        Return results

    End Function

    Public Shared Function SetState(ByVal URL As String, ByVal POSTData As Generic.List(Of State_Class), Optional ByVal UserName As String = "", Optional ByVal UserPass As String = "") As String

        Try

            Dim serializer As New JavaScriptSerializer()
            Dim serializedResult As String = serializer.Serialize(POSTData)

            serializedResult = Mid(serializedResult, 2, serializedResult.Length - 2) 'Remove the brackets, data is not in array

            Return WRequest(URL, "POST", serializedResult, UserName, UserPass)

        Catch ex As Exception
            Return ex.Message
        End Try

    End Function

    Public Shared Function GetExitConditions(ByVal URL As String, Optional ByVal UserName As String = "", Optional ByVal UserPass As String = "") As List(Of ExitConditions_Class)

        Dim TempData As String = ""

        TempData = WRequest(URL, "GET", , UserName, UserPass)

        Dim js As New JavaScriptSerializer
        Dim results As List(Of ExitConditions_Class) = js.Deserialize(Of List(Of ExitConditions_Class))(TempData)

        Return results

    End Function

    Public Shared Function SetExitConditions(ByVal URL As String, ByVal POSTData As Generic.List(Of ExitConditions_Class), Optional ByVal UserName As String = "", Optional ByVal UserPass As String = "") As String

        Try

            Dim serializer As New JavaScriptSerializer()
            Dim serializedResult As String = serializer.Serialize(POSTData)

            Return WRequest(URL, "POST", serializedResult, UserName, UserPass)

        Catch ex As Exception
            Return ex.Message
        End Try

    End Function

    Public Shared Function GetOutputControllers(ByVal URL As String, Optional ByVal UserName As String = "", Optional ByVal UserPass As String = "") As List(Of OutputControllers_Class)

        Dim TempData As String = ""

        TempData = WRequest(URL, "GET", , UserName, UserPass)

        Dim js As New JavaScriptSerializer
        Dim results As List(Of OutputControllers_Class) = js.Deserialize(Of List(Of OutputControllers_Class))(TempData)

        Return results

    End Function

    Public Shared Function SetOutputControllers(ByVal URL As String, ByVal POSTData As Generic.List(Of OutputControllers_Class), Optional ByVal UserName As String = "", Optional ByVal UserPass As String = "") As String

        Try

            Dim serializer As New JavaScriptSerializer()
            Dim serializedResult As String = serializer.Serialize(POSTData)

            serializedResult = Mid(serializedResult, 2, serializedResult.Length - 2) 'Remove the brackets, data is not in array

            Return WRequest(URL, "POST", serializedResult, UserName, UserPass)

        Catch ex As Exception
            Return ex.Message
        End Try

    End Function

    Public Shared Function GetProcessTimer(ByVal URL As String, Optional ByVal UserName As String = "", Optional ByVal UserPass As String = "") As ProcessTimer_Class

        Dim TempData As String = ""

        TempData = WRequest(URL, "GET", , UserName, UserPass)
        Dim js As New JavaScriptSerializer
        Dim results As ProcessTimer_Class = js.Deserialize(Of ProcessTimer_Class)(TempData)

        Return results

    End Function

    Public Shared Function SetProcessTimer(ByVal URL As String, ByVal POSTData As Generic.List(Of ProcessTimer_Class), Optional ByVal UserName As String = "", Optional ByVal UserPass As String = "") As String

        Try

            Dim serializer As New JavaScriptSerializer()
            Dim serializedResult As String = serializer.Serialize(POSTData)

            serializedResult = Mid(serializedResult, 2, serializedResult.Length - 2) 'Remove the brackets, data is not in array

            Return WRequest(URL, "POST", serializedResult, UserName, UserPass)

        Catch ex As Exception
            Return ex.Message
        End Try

    End Function

    Public Shared Function WRequest(ByVal URL As String, ByVal method As String, Optional ByVal data As String = "", Optional ByVal UserName As String = "", Optional ByVal UserPass As String = "") As String

        Try
            Dim responseData As String = ""
            Dim request As HttpWebRequest = Nothing

            request = HttpWebRequest.Create(URL.ToLower)
            request.Method = method
            request.ContentType = "application/json"

            If request.Proxy IsNot Nothing Then
                request.Credentials = New NetworkCredential(UserName, UserPass)
            End If

            request.ProtocolVersion = HttpVersion.Version10

            If method = "POST" Then
                Dim encoding As New UTF8Encoding
                Dim postByteArray() As Byte = encoding.GetBytes(data)
                request.ContentLength = postByteArray.Length
                Dim postStream As Stream = request.GetRequestStream()
                postStream.Write(postByteArray, 0, postByteArray.Length)
                postStream.Close()
            End If

            Dim response As HttpWebResponse = request.GetResponse()
            If response.StatusCode = HttpStatusCode.OK Then
                Dim responseStream As StreamReader = New StreamReader(response.GetResponseStream())
                responseData = responseStream.ReadToEnd()
            End If

            response.Close()
            Return responseData

        Catch ex As Exception
            Return ex.Message
        End Try

    End Function

End Class

Public Class Temp_Class

    Public Property name() As String
        Get
            Return m_name
        End Get
        Set(ByVal value As String)
            m_name = value
        End Set
    End Property

    Private m_name As String

    Public Property temp() As Integer
        Get
            Return m_temp
        End Get
        Set(ByVal value As Integer)
            m_temp = value
        End Set
    End Property

    Private m_temp As Integer

    Public Property setpoint() As String
        Get
            Return m_setpoint
        End Get
        Set(ByVal value As String)
            m_setpoint = value
        End Set
    End Property

    Private m_setpoint As Integer

    Public Property enabled() As Boolean
        Get
            Return m_enabled
        End Get
        Set(ByVal value As Boolean)
            m_enabled = value
        End Set
    End Property

    Private m_enabled As Boolean

    Public Property coefficients() As List(Of Double)
        Get
            Return m_coefficients
        End Get
        Set(ByVal value As List(Of Double))
            m_coefficients = value
        End Set
    End Property

    Private m_coefficients As List(Of Double)

End Class

Public Class Din_Class

    Public Property name() As String
        Get
            Return m_name
        End Get
        Set(ByVal value As String)
            m_name = value
        End Set
    End Property

    Private m_name As String

    Public Property [on]() As Boolean
        Get
            Return m_on
        End Get
        Set(ByVal value As Boolean)
            m_on = value
        End Set
    End Property

    Private m_on As Boolean

    Public Property enabled() As Boolean
        Get
            Return m_enabled
        End Get
        Set(ByVal value As Boolean)
            m_enabled = value
        End Set
    End Property

    Private m_enabled As Boolean

    Public Property oneshot() As Boolean
        Get
            Return m_oneshot
        End Get
        Set(ByVal value As Boolean)
            m_oneshot = value
        End Set
    End Property

    Private m_oneshot As Boolean

End Class

Public Class Output_Class

    Public Property name() As String
        Get
            Return m_name
        End Get
        Set(ByVal value As String)
            m_name = value
        End Set
    End Property

    Private m_name As String

    Public Property [on]() As Boolean
        Get
            Return m_on
        End Get
        Set(ByVal value As Boolean)
            m_on = value
        End Set
    End Property

    Private m_on As Boolean

    Public Property enabled() As Boolean
        Get
            Return m_enabled
        End Get
        Set(ByVal value As Boolean)
            m_enabled = value
        End Set
    End Property

    Private m_enabled As Boolean

End Class

Public Class CurrentState
    Public Property state() As Integer
        Get
            Return m_state
        End Get
        Set(ByVal value As Integer)
            m_state = Value
        End Set
    End Property
    Private m_state As Integer
End Class

Public Class Process_Class

    Public Property name() As String
        Get
            Return m_name
        End Get
        Set(ByVal value As String)
            m_name = value
        End Set
    End Property

    Private m_name As String

    Public Property running() As Boolean
        Get
            Return m_running
        End Get
        Set(ByVal value As Boolean)
            m_running = value
        End Set
    End Property

    Private m_running As Boolean

    Public Property paused() As Boolean
        Get
            Return m_paused
        End Get
        Set(ByVal value As Boolean)
            m_paused = value
        End Set
    End Property
    Private m_paused As Boolean

    Public Property run_on_startup() As Boolean
        Get
            Return m_run_on_startup
        End Get
        Set(ByVal value As Boolean)
            m_run_on_startup = value
        End Set
    End Property

    Private m_run_on_startup As Boolean

    Public Property current_state() As CurrentState
        Get
            Return m_current_state
        End Get
        Set(ByVal value As CurrentState)
            m_current_state = value
        End Set
    End Property

    Private m_current_state As CurrentState

    Public Property states() As List(Of String)
        Get
            Return m_states
        End Get
        Set(ByVal value As List(Of String))
            m_states = value
        End Set
    End Property

    Private m_states As List(Of String)

End Class

Public Class Timer_Class

    Public Property used() As Boolean
        Get
            Return m_used
        End Get
        Set(ByVal value As Boolean)
            m_used = value
        End Set
    End Property

    Private m_used As Boolean

    Public Property count_up() As Boolean
        Get
            Return m_count_up
        End Get
        Set(ByVal value As Boolean)
            m_count_up = value
        End Set
    End Property

    Private m_count_up As Boolean

    Public Property init() As Integer
        Get
            Return m_init
        End Get
        Set(ByVal value As Integer)
            m_init = value
        End Set
    End Property

    Private m_init As Integer

    Public Property preserve() As Boolean
        Get
            Return m_preserve
        End Get
        Set(ByVal value As Boolean)
            m_preserve = value
        End Set
    End Property

    Private m_preserve As Boolean

End Class

Public Class Ramp_Class

    Public Property enable() As Boolean
        Get
            Return m_enable
        End Get
        Set(ByVal value As Boolean)
            m_enable = value
        End Set
    End Property

    Private m_enable As Boolean

    Public Property output() As Integer
        Get
            Return m_output
        End Get
        Set(ByVal value As Integer)
            m_output = value
        End Set
    End Property

    Private m_output As Integer

    Public Property start() As Integer
        Get
            Return m_start
        End Get
        Set(ByVal value As Integer)
            m_start = value
        End Set
    End Property

    Private m_start As Integer

    Public Property [end]() As Integer
        Get
            Return m_end
        End Get
        Set(ByVal value As Integer)
            m_end = value
        End Set
    End Property

    Private m_end As Integer

    Public Property time() As Integer
        Get
            Return m_time
        End Get
        Set(ByVal value As Integer)
            m_time = value
        End Set
    End Property

    Private m_time As Integer

End Class

Public Class State_Class

    Public Property name() As String
        Get
            Return m_name
        End Get
        Set(ByVal value As String)
            m_name = value
        End Set
    End Property

    Private m_name As String

    Public Property timers() As List(Of Timer_Class)
        Get
            Return m_timers
        End Get
        Set(ByVal value As List(Of Timer_Class))
            m_timers = value
        End Set
    End Property

    Private m_timers As List(Of Timer_Class)

    Public Property ramp() As Ramp_Class
        Get
            Return m_ramp
        End Get
        Set(ByVal value As Ramp_Class)
            m_ramp = value
        End Set
    End Property

    Private m_ramp As Ramp_Class

    Public Property process_spawn() As List(Of Integer)
        Get
            Return m_process_spawn
        End Get
        Set(ByVal value As List(Of Integer))
            m_process_spawn = value
        End Set
    End Property

    Private m_process_spawn As List(Of Integer)

    Public Property process_kill() As List(Of Integer)
        Get
            Return m_process_kill
        End Get
        Set(ByVal value As List(Of Integer))
            m_process_kill = value
        End Set
    End Property

    Private m_process_kill As List(Of Integer)

    Public Property state_alarm() As Integer
        Get
            Return m_state_alarm
        End Get
        Set(ByVal value As Integer)
            m_state_alarm = value
        End Set
    End Property

    Private m_state_alarm As Integer

    Public Property email_alarm() As Boolean
        Get
            Return m_email_alarm
        End Get
        Set(ByVal value As Boolean)
            m_email_alarm = value
        End Set
    End Property

    Private m_email_alarm As Boolean

    Public Property registers() As List(Of Integer)
        Get
            Return m_registers
        End Get
        Set(ByVal value As List(Of Integer))
            m_registers = value
        End Set
    End Property

    Private m_registers As List(Of Integer)

End Class

Public Class ExitConditions_Class

    Public Property enabled() As Boolean
        Get
            Return m_enabled
        End Get
        Set(ByVal value As Boolean)
            m_enabled = value
        End Set
    End Property

    Private m_enabled As Boolean

    Public Property source_type() As Integer
        Get
            Return m_source_type
        End Get
        Set(ByVal value As Integer)
            m_source_type = value
        End Set
    End Property

    Private m_source_type As Integer

    Public Property source_number() As Integer
        Get
            Return m_source_number
        End Get
        Set(ByVal value As Integer)
            m_source_number = value
        End Set
    End Property

    Private m_source_number As Integer

    Public Property next_state() As Integer
        Get
            Return m_next_state
        End Get
        Set(ByVal value As Integer)
            m_next_state = value
        End Set
    End Property

    Private m_next_state As Integer

    Public Property condition() As Integer
        Get
            Return m_condition
        End Get
        Set(ByVal value As Integer)
            m_condition = value
        End Set
    End Property

    Private m_condition As Integer

    Public Property value() As Integer
        Get
            Return m_value
        End Get
        Set(ByVal value As Integer)
            m_value = value
        End Set
    End Property

    Private m_value As Integer

End Class

Public Class OutputControllers_Class

    Public Property mode() As Integer
        Get
            Return m_mode
        End Get
        Set(ByVal value As Integer)
            m_mode = value
        End Set
    End Property

    Private m_mode As Integer

    Public Property heat() As Boolean
        Get
            Return m_heat
        End Get
        Set(ByVal value As Boolean)
            m_heat = value
        End Set
    End Property

    Private m_heat As Boolean

    Public Property input() As Integer
        Get
            Return m_input
        End Get
        Set(ByVal value As Integer)
            m_input = value
        End Set
    End Property

    Private m_input As Integer

    Public Property swing() As Integer
        Get
            Return m_swing
        End Get
        Set(ByVal value As Integer)
            m_swing = value
        End Set
    End Property

    Private m_swing As Integer

    Public Property setpoint() As Integer
        Get
            Return m_setpoint
        End Get
        Set(ByVal value As Integer)
            m_setpoint = value
        End Set
    End Property

    Private m_setpoint As Integer

End Class

Public Class ProcessTimer_Class

    Public Property name() As String
        Get
            Return m_name
        End Get
        Set(ByVal value As String)
            m_name = value
        End Set
    End Property

    Private m_name As String

    Public Property value() As Integer
        Get
            Return m_value
        End Get
        Set(ByVal value As Integer)
            m_value = value
        End Set
    End Property

    Private m_value As Integer

    Public Property [on]() As Boolean
        Get
            Return m_on
        End Get
        Set(ByVal value As Boolean)
            m_on = value
        End Set
    End Property

    Private m_on As Boolean

    Public Property enabled() As Boolean
        Get
            Return m_enabled
        End Get
        Set(ByVal value As Boolean)
            m_enabled = value
        End Set
    End Property

    Private m_enabled As Boolean

    Public Property count_up() As Boolean
        Get
            Return m_count_up
        End Get
        Set(ByVal value As Boolean)
            m_count_up = value
        End Set
    End Property

    Private m_count_up As Boolean

End Class